#include "robot_controller.h"
#include "state_funcs.h"

#include <stdio.h>

int state = 0;
int count = 0;
int flag_jack = 0;

// les sous-tats
int movegauche_state = 0;

#define MAX_SPEED 0.4;


char* __EXPORT cdecl GetDescription(void)
{
 	return "@version 13/03/2006";
}
              
/**
 * Affiche un message sur le priphrique de sortie
 * remplacer par le code de Gilles, ou quivalent selon le priphrique 
 */
void log(char* msg) {
	printf(msg);
}

/**
 * Dmarrage du robot, premier tat
 */
void initRobot(void) {
	log("Init Robot\n");
   // tests des cartes filles ?
   // premier tat : attente du jack en entre
   // SIMU : passer tout de suite  jackout
   state = ST_JACKOUT;
   entryJackout();
	// les sous-tats
	movegauche_state = 0;
}


/**
 * Analyse le robot, gre les timers, ... (code de Gilles)
 */
void analyseRobot(float new_time) {

}


/************************/
/******** ENTRY *********/
/************************/
void entryWaitjk() {
	//
   log("En attente du jack\n");
}

void entryJackin() {
 	//
   log("Jack entr\n");
}

void entryJackout() {
 	//
   log("Et c'est parti !\n");
   // initialiser le compteur
   //  remplacer par la routine du simulateur (nb de seconde)
	count = 0;
} 

void entryMovegauche() {
 	//
   log("Mouvement par la gauche\n");
   //
   movegauche_state = MG_CAP90;
}

void entryChercheballe() {
 	//
   log("Recherche balle\n");
}

/************************/
/********* DO ***********/
/************************/
void doWaitjk() {
	// vrifier une panne ??
	// attendre le jack
   if (flag_jack == 1) {
   	state=ST_JACKIN;
    	exitWaitjk();
      entryJackin();
   }
}

void doJackin() {
 	// attendre la sortie du jack
   if (flag_jack == 0) {
   	state=ST_JACKOUT;
      exitJackin();
      entryJackout();
   }
}

void doJackout() {
 	// analyser le terrain au dmarrage
	log("Do jackout\n");   
   // choisir une stratgie
   // MODE SIMU : partir  gauche
   state=ST_MOVEGAUCHE;
   exitJackout();
   entryMovegauche();

   // autre possibilit, partir en recherche de balles
   /*
	state=ST_CHERCHEBALLE;
   exitJackout();
   entryChercheballe();
   */

}             

/**
 * Le mouvement  gauche permet de parcourir le terrain par la gauche du robot
 * dans le cas o les totems ne se trouvent pas sur le trajet (analyse camra)
 */
void doMovegauche(CONTROLLER_INPUTS_PTR inputs, 	// pointeur sur les informations en entre
  CONTROLLER_OUTPUTS_PTR outputs) 						// pointeur sur les consignes en sortie)
{
   // le mouvement gauche est lui mme soumis  des tats
   switch (movegauche_state) {
    	case MG_CAP90:
         // le mouvement  faire
         if (inputs->heading < 90) {
	         outputs->motor_left = -MAX_SPEED;
   	      outputs->motor_right = MAX_SPEED;
         } else {
      	   outputs->motor_left = MAX_SPEED;
         	outputs->motor_right = -MAX_SPEED;
         }
         // la condition de sortie
			if (inputs->heading >= 89 && inputs->heading <= 91) {
				outputs->motor_left = 0;
				outputs->motor_right = 0;
	         movegauche_state = MG_AV33MX;
         }
      	break;
      case MG_AV33MX:
      	// le mouvement  faire
        	outputs->motor_left = MAX_SPEED;
        	outputs->motor_right = MAX_SPEED;
         // la condition de sortie
      	if (inputs->x < -40.0) {
	         // position atteinte
				outputs->motor_left = 0;
				outputs->motor_right = 0;
         	movegauche_state = MG_CAP45;
         }
         if (inputs->heading < 85.0 || inputs->heading > 95.0) {
          	// revenir  la recherche du cap
				movegauche_state = MG_CAP90;
			}
   		break;
    	case MG_CAP45:
         // le mouvement  faire     
         if (inputs->heading < 50) {
	         outputs->motor_left = -MAX_SPEED;
   	      outputs->motor_right = MAX_SPEED;
         } else {
      	   outputs->motor_left = MAX_SPEED;
         	outputs->motor_right = -MAX_SPEED;
         }
         // la condition de sortie
			if (inputs->heading >= 50 && inputs->heading <= 52) {
				outputs->motor_left = 0;
				outputs->motor_right = 0;
	         movegauche_state = MG_AV68MX;
         }
      	break;
    	case MG_AV68MX:
         // le mouvement  faire
         outputs->motor_left = MAX_SPEED;
         outputs->motor_right = MAX_SPEED;
         // la condition de sortie
			if (inputs->x < -92) {
				outputs->motor_left = 0;
				outputs->motor_right = 0;
	         movegauche_state = MG_CAP0;
         }
       	if (inputs->heading < 50 || inputs->heading > 52) {
			 	// revenir  la recherche du cap
				movegauche_state = MG_CAP45;
         }
      	break;
    	case MG_CAP0:
         // le mouvement  faire     
         if (inputs->heading < 0) {
	         outputs->motor_left = -MAX_SPEED;
   	      outputs->motor_right = MAX_SPEED;
         } else {
      	   outputs->motor_left = MAX_SPEED;
         	outputs->motor_right = -MAX_SPEED;
         }
         // la condition de sortie
			if (inputs->heading >= -2 && inputs->heading <= 2) {
				outputs->motor_left = 0;
				outputs->motor_right = 0;
	         movegauche_state = MG_AV45MY;
         }
      	break;
    	case MG_AV45MY:
         // le mouvement  faire
         outputs->motor_left = MAX_SPEED;
         outputs->motor_right = MAX_SPEED;
         // la condition de sortie
			if (inputs->y > -45) {
				outputs->motor_left = 0;
				outputs->motor_right = 0;
	         movegauche_state = MG_FIN;
         }
       	if (inputs->heading < -2 || inputs->heading > 2) {
			 	// revenir  la recherche du cap
				movegauche_state = MG_CAP0;
         }
      	break;
   }
   // avancer jusqu' -331
   // pivoter  xx 
   //


	// conditions de sortie :
   // - si la position est atteinte
   if (movegauche_state == MG_FIN) {
		
   }
   // - si le robot a dpass un certain temps
   // - autres vnements, camra ?, capteurs de contact ?
   // TODO
}

/************************/
/******** EXIT **********/
/************************/
void exitWaitjk() {
	// nope
}

void exitJackin() {
 	// nope
}

void exitJackout() {
 	// nope
}

void exitMovegauche() {
 	// nope
}


void __EXPORT cdecl Init(void) {
 	initRobot();
}

void __EXPORT cdecl Reset(void) {
 	initRobot();
}

void __EXPORT cdecl Progress(
	float delta_time,								// delta entre cette invocation et la prcdente (en secondes)
  float new_time,									// temps coul
  CONTROLLER_INPUTS_PTR inputs, 	// pointeur sur les informations en entre
  CONTROLLER_OUTPUTS_PTR outputs 	// pointeur sur les consignes en sortie
)
{
	//printf("(%f,%f)\n",inputs->x,inputs->y);
	analyseRobot(new_time);
	switch (state) {
   	case ST_WAITJK:
			doWaitjk();
			break;
		case ST_JACKIN:
			doJackin();
			break;
		case ST_JACKOUT:
			doJackout();
			break;
		case ST_MOVEGAUCHE:
			doMovegauche(inputs,outputs);
			break;
	}


}

